import { ComponentConstructor } from 'preact';
import { DispatchResult, Dispatcher } from './dispatch';
import { Cmd } from './cmd';
export interface ComponentDefinition<Model, Msg, Props> {
    model: Model;
    update(msg: DispatchResult<Msg>, model: Model): Model | [Model, Cmd<Msg>];
    view(model: Model, dispatch: Dispatcher<Msg>): JSX.Element | null;
    init?(model: Model, dispatch: Dispatcher<Msg>): void;
    props?(props: Props, dispatch: Dispatcher<Msg>): void;
}
export declare function component<Model, Msg, Props = {}>(comp: ComponentDefinition<Model, Msg, Props>): ComponentConstructor<Props, Model>;
